
clear;
addpath common_innerdist;
addpath SVM-KM;
addpath SVM-KMExample;

ifig = 1;
%--Train data set
s1 = 'dataset/person1/';
s2 = 'dataset/person2/';
s3 = 'dataset/person3/';
s4 = 'dataset/person4/';
s4 = 'dataset/person5/';

n_class = 2;
n_obj = 8;

%-- shape context parameters
n_dist		= 5;
n_theta		= 12;
bTangent	= 1;
bSmoothCont	= 1;
n_contsamp	= 200;
b_simplecont= 1;


accuracy = 0;
for i=1:5
    c1 = mod(i,5);
    c2 = mod(i+1,5);
    c3 = mod(i+2,5);
    c4 = mod(i+3,5);
    c5 = mod(i+4,5);
    sets = [c1;c2;c3;c4;c5];
    training_data = [];
    groups = [];
    
    for j=1:5
        %-- FILEs --------------------------------------------
        %-- Training-----------------------
        p = sets(j);
        if p == 0
            p = 5;
        end
        sdir = ['dataset/person' i2s(p) '/'];
        sDisAngSamp	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
        sCont		= [sdir 'articu_cont_' i2s(n_contsamp) '.mat'];
        s_articu_sc	= [sdir 'IDSC' sDisAngSamp '.mat'];

        %-- Extract contours -------------------------------------------------------------
        %-- Training -----------------------------
        if 1
            [articu_cont] = batch_contour_f(sdir,n_class,n_obj);
            [articu_cont] = batch_contour_f(sdir,n_class,n_obj,n_contsamp);
        else
                load(sCont);
        end

        %-- Compute or Load all the shape context data ------------------------------------
        %-- Training ------------------------------------------------
        if 1
            [articu_sc] = batch_comp_normal_sc(sdir,sCont,n_dist, n_theta, bTangent,n_class,n_obj);
            save(s_articu_sc, 'articu_sc');
        else
            load(s_articu_sc);
        end

        %total_sc{1,i} = articu_sc;

        for iC=1:n_class
            sc = articu_sc;
            for i0=1:n_obj
                    %fprintf('----------------\n');
                sctemp = reshape(sc{1,i0},1,60*200);
                training_data = [training_data;sctemp];
                groups = [groups;iC];
            end
        end
    end
   
    if c5 == 0
        c5 = 5;
    end
    test_dir = ['dataset/person' i2s(c5) '/'];
    %-- Testing -----------------------
    test_DisAngSamp	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
    test_Cont		= [test_dir 'test_articu_cont_' i2s(n_contsamp) '.mat'];
    t_articu_sc	= [test_dir 'IDSC' test_DisAngSamp '.mat'];

    %-- Testing Contours------------------------------
    if 1
        [test_articu_cont] = test_contour_f(test_dir,n_class, n_obj);
        [test_articu_cont] = test_contour_f(test_dir,n_class, n_obj,n_contsamp);
    end

    if 1
        [test_articu_sc] = test_comp_normal_sc(test_dir,test_Cont,n_dist, n_theta, bTangent,n_class,n_obj);
        %save(t_articu_sc, 'test_articu_sc');
    end
    svmModel = svmtrain(training_data, groups, ...,
                        'Kernel_Function','linear');

    %sctemp = reshape(test_articu_sc,1,60*200);
    [classes,cp] = svm_classify_old(svmModel,test_articu_cont, test_articu_sc);
    
    cp.CorrectRate
    accuracy = accuracy + cp.CorrectRate;
end

accuracy = accuracy/4