
clear;
addpath common_innerdist;
addpath SVM-KM;
addpath SVM-KMExample;

ifig = 1;
%--Train data set
s1 = 'dataset/signs/one/train/';
s2 = 'dataset/signs/two/train/';
s3 = 'dataset/signs/three/train/';
s4 = 'dataset/signs/four/train/';
s5 = 'dataset/signs/five/train/';
s6 = 'dataset/signs/call/train/';
s7 = 'dataset/signs/thumbs/train/';

%-- Test data set
t1 = 'dataset/signs/one/test/';
t2 = 'dataset/signs/two/test/';
t3 = 'dataset/signs/three/test/';
t4 = 'dataset/signs/four/test/';
t5 = 'dataset/signs/five/test/';
t6 = 'dataset/signs/call/test/';
t7 = 'dataset/signs/thumbs/test/';

n_class = 7;
n_obj = 30;

%-- shape context parameters
n_dist		= 5;
n_theta		= 12;
bTangent	= 1;
bSmoothCont	= 1;
n_contsamp	= 200;
b_simplecont= 1;

%-- FILEs --------------------------------------------
%-- Training one-----------------------
sDisAngSamp1	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
sCont1		= [s1 'articu_cont_' i2s(n_contsamp) '.mat'];
s_articu_sc1	= [s1 'IDSC' sDisAngSamp1 '.mat'];

%-- Testing one -----------------------
test_DisAngSamp1	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
test_Cont1		= [t1 'test_articu_cont_' i2s(n_contsamp) '.mat'];
t_articu_sc1	= [t1 'IDSC' test_DisAngSamp1 '.mat'];

%-- Training two-----------------------
sDisAngSamp2	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
sCont2		= [s2 'articu_cont_' i2s(n_contsamp) '.mat'];
s_articu_sc2	= [s2 'IDSC' sDisAngSamp2 '.mat'];

%-- Testing two-----------------------
test_DisAngSamp2	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
test_Cont2		= [t2 'test_articu_cont_' i2s(n_contsamp) '.mat'];
t_articu_sc2	= [t2 'IDSC' test_DisAngSamp2 '.mat'];

%-- Training three-----------------------
sDisAngSamp3	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
sCont3		= [s3 'articu_cont_' i2s(n_contsamp) '.mat'];
s_articu_sc3	= [s3 'IDSC' sDisAngSamp3 '.mat'];

%-- Testing three-----------------------
test_DisAngSamp3	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
test_Cont3		= [t3 'test_articu_cont_' i2s(n_contsamp) '.mat'];
t_articu_sc3	= [t3 'IDSC' test_DisAngSamp3 '.mat'];

%-- Training four-----------------------
sDisAngSamp4	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
sCont4		= [s4 'articu_cont_' i2s(n_contsamp) '.mat'];
s_articu_sc4	= [s4 'IDSC' sDisAngSamp4 '.mat'];

%-- Testing four-----------------------
test_DisAngSamp4	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
test_Cont4		= [t4 'test_articu_cont_' i2s(n_contsamp) '.mat'];
t_articu_sc4	= [t4 'IDSC' test_DisAngSamp4 '.mat'];


%-- Training five-----------------------
sDisAngSamp5	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
sCont5		= [s5 'articu_cont_' i2s(n_contsamp) '.mat'];
s_articu_sc5	= [s5 'IDSC' sDisAngSamp5 '.mat'];

%-- Testing five-----------------------
test_DisAngSamp5	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
test_Cont5		= [t5 'test_articu_cont_' i2s(n_contsamp) '.mat'];
t_articu_sc5	= [t5 'IDSC' test_DisAngSamp5 '.mat'];

%-- Training call-----------------------
sDisAngSamp6	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
sCont6		= [s6 'articu_cont_' i2s(n_contsamp) '.mat'];
s_articu_sc6	= [s6 'IDSC' sDisAngSamp6 '.mat'];

%-- Testing call-----------------------
test_DisAngSamp6	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
test_Cont6		= [t6 'test_articu_cont_' i2s(n_contsamp) '.mat'];
t_articu_sc6	= [t6 'IDSC' test_DisAngSamp6 '.mat'];

%-- Training thumbs-----------------------
sDisAngSamp7	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
sCont7		= [s7 'articu_cont_' i2s(n_contsamp) '.mat'];
s_articu_sc7	= [s7 'IDSC' sDisAngSamp7 '.mat'];

%-- Testing thumbs-----------------------
test_DisAngSamp7	= ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
test_Cont7		= [t7 'test_articu_cont_' i2s(n_contsamp) '.mat'];
t_articu_sc7	= [t7 'IDSC' test_DisAngSamp7 '.mat'];

%---------------------------------------------------------

%-- Extract contours -------------------------------------------------------------
%-- Training1 -----------------------------
if 1
	[articu_cont1] = signbatch_contour_f(s1,'one',1,n_obj);
	[articu_cont1] = signbatch_contour_f(s1,'one',1,n_obj,n_contsamp);
else
        load(sCont1);
end
%-- Testing1 ------------------------------
if 1
	[test_articu_cont1] = signtest_contour_f(t1,'one',59);
	[test_articu_cont1] = signtest_contour_f(t1,'one',59,n_contsamp);
else
    load(test_Cont1);
end

%-- Training2 -----------------------------
if 1
	[articu_cont2] = signbatch_contour_f(s2,'two',1,n_obj);
	[articu_cont2] = signbatch_contour_f(s2,'two',1,n_obj,n_contsamp);
else
        load(sCont2);
end
%-- Testing2 ------------------------------
if 1
	[test_articu_cont2] = signtest_contour_f(t2,'two',57);
	[test_articu_cont2] = signtest_contour_f(t2,'two',57,n_contsamp);
else
    load(test_Cont2);
end

%-- Training3 -----------------------------
if 1
	[articu_cont3] = signbatch_contour_f(s3,'three',1,n_obj);
	[articu_cont3] = signbatch_contour_f(s3,'three',1,n_obj,n_contsamp);
else
        load(sCont3);
end
%-- Testing3 ------------------------------
if 1
	[test_articu_cont3] = signtest_contour_f(t3,'three',47);
	[test_articu_cont3] = signtest_contour_f(t3,'database',47,n_contsamp);
else
    load(test_Cont3);
end

%-- Training4 -----------------------------
if 1
	[articu_cont4] = signbatch_contour_f(s4,'four',1,n_obj);
	[articu_cont4] = signbatch_contour_f(s4,'four',1,n_obj,n_contsamp);
else
        load(sCont4);
end
%-- Testing4 ------------------------------
if 1
	[test_articu_cont4] = signtest_contour_f(t4,'four',64);
	[test_articu_cont4] = signtest_contour_f(t4,'four',64,n_contsamp);
else
    load(test_Cont4);
end

%-- Training5 -----------------------------
if 1
	[articu_cont5] = signbatch_contour_f(s5,'five',1,n_obj);
	[articu_cont5] = signbatch_contour_f(s5,'five',1,n_obj,n_contsamp);
else
        load(sCont5);
end
%-- Testing5 ------------------------------
if 1
	[test_articu_cont5] = signtest_contour_f(t5,'five',76);
	[test_articu_cont5] = signtest_contour_f(t5,'five',76,n_contsamp);
else
    load(test_Cont5);
end

%-- Training6 -----------------------------
if 1
	[articu_cont6] = signbatch_contour_f(s6,'call',1,n_obj);
	[articu_cont6] = signbatch_contour_f(s6,'call',1,n_obj,n_contsamp);
else
        load(sCont6);
end
%-- Testing6 ------------------------------
if 1
	[test_articu_cont6] = signtest_contour_f(t6,'call',48);
	[test_articu_cont6] = signtest_contour_f(t6,'call',48,n_contsamp);
else
    load(test_Cont6);
end

%-- Training7 -----------------------------
if 1
	[articu_cont7] = signbatch_contour_f(s7,'thumbs',1,n_obj);
	[articu_cont7] = signbatch_contour_f(s7,'thumbs',1,n_obj,n_contsamp);
else
        load(sCont7);
end
%-- Testing7 ------------------------------
if 1
	[test_articu_cont7] = signtest_contour_f(t7,'thumbs',74);
	[test_articu_cont7] = signtest_contour_f(t7,'thumbs',74,n_contsamp);
else
    load(test_Cont7);
end


%-- Compute or Load all the shape context data
%--Training 1---------------------------------
if 1
    [articu_sc1] = signbatch_comp_articu_sc(s1,'one',sCont1,n_dist, n_theta, bTangent, bSmoothCont,1,n_obj,b_simplecont);
    save(s_articu_sc1, 'articu_sc1');
else
    load(s_articu_sc1);
end
%-- Testing1 -------------------------------------------------
if 1
    [test_articu_sc1] = signtest_comp_articu_sc(t1,'one',test_Cont1,n_dist, n_theta, bTangent, bSmoothCont,b_simplecont);
    save(t_articu_sc1, 'test_articu_sc1');
else
    load(t_articu_sc1);
end

%--Training 2---------------------------------
if 1
    [articu_sc2] = signbatch_comp_articu_sc(s2,'two',sCont2,n_dist, n_theta, bTangent, bSmoothCont,1,n_obj,b_simplecont);
    save(s_articu_sc2, 'articu_sc2');
else
    load(s_articu_sc2);
end
%-- Testing2 -------------------------------------------------
if 1
    [test_articu_sc2] = signtest_comp_articu_sc(t2,'two',test_Cont2,n_dist, n_theta, bTangent, bSmoothCont,b_simplecont);
    save(t_articu_sc2, 'test_articu_sc2');
else
    load(t_articu_sc2);
end

%--Training 3---------------------------------
if 1
    [articu_sc3] = signbatch_comp_articu_sc(s3,'three',sCont3,n_dist, n_theta, bTangent, bSmoothCont,1,n_obj,b_simplecont);
    save(s_articu_sc3, 'articu_sc3');
else
    load(s_articu_sc3);
end
%-- Testing3 -------------------------------------------------
if 1
    [test_articu_sc3] = signtest_comp_articu_sc(t3,'three',test_Cont3,n_dist, n_theta, bTangent, bSmoothCont,b_simplecont);
    save(t_articu_sc3, 'test_articu_sc3');
else
    load(t_articu_sc3);
end

%--Training 4---------------------------------
if 1
    [articu_sc4] = signbatch_comp_articu_sc(s4,'four',sCont4,n_dist, n_theta, bTangent, bSmoothCont,1,n_obj,b_simplecont);
    save(s_articu_sc4, 'articu_sc4');
else
    load(s_articu_sc4);
end
%-- Testing4 -------------------------------------------------
if 1
    [test_articu_sc4] = signtest_comp_articu_sc(t4,'four',test_Cont4,n_dist, n_theta, bTangent, bSmoothCont,b_simplecont);
    save(t_articu_sc4, 'test_articu_sc4');
else
    load(t_articu_sc4);
end

%--Training 5---------------------------------
if 1
    [articu_sc5] = signbatch_comp_articu_sc(s5,'five',sCont5,n_dist, n_theta, bTangent, bSmoothCont,1,n_obj,b_simplecont);
    save(s_articu_sc5, 'articu_sc5');
else
    load(s_articu_sc5);
end
%-- Testing5 -------------------------------------------------
if 1
    [test_articu_sc5] = signtest_comp_articu_sc(t5,'five',test_Cont5,n_dist, n_theta, bTangent, bSmoothCont,b_simplecont);
    save(t_articu_sc5, 'test_articu_sc5');
else
    load(t_articu_sc5);
end

%--Training 6---------------------------------
if 1
    [articu_sc6] = signbatch_comp_articu_sc(s6,'call',sCont6,n_dist, n_theta, bTangent, bSmoothCont,1,n_obj,b_simplecont);
    save(s_articu_sc6, 'articu_sc6');
else
    load(s_articu_sc6);
end
%-- Testing6 -------------------------------------------------
if 1
    [test_articu_sc6] = signtest_comp_articu_sc(t6,'call',test_Cont6,n_dist, n_theta, bTangent, bSmoothCont,b_simplecont);
    save(t_articu_sc6, 'test_articu_sc6');
else
    load(t_articu_sc6);
end

%--Training 7---------------------------------
if 1
    [articu_sc7] = signbatch_comp_articu_sc(s7,'thumbs',sCont7,n_dist, n_theta, bTangent, bSmoothCont,1,n_obj,b_simplecont);
    save(s_articu_sc7, 'articu_sc7');
else
    load(s_articu_sc7);
end
%-- Testing7 -------------------------------------------------
if 1
    [test_articu_sc7] = signtest_comp_articu_sc(t7,'thumbs',test_Cont7,n_dist, n_theta, bTangent, bSmoothCont,b_simplecont);
    save(t_articu_sc7, 'test_articu_sc7');
else
    load(t_articu_sc7);
end

%##########################################################################
% Multiclass SVM
%##########################################################################

%--Training SVM -------------------
articu_sc = cell(1,7);
articu_sc{1,1} = articu_sc1;
articu_sc{1,2} = articu_sc2;
articu_sc{1,3} = articu_sc3;
articu_sc{1,4} = articu_sc4;
articu_sc{1,5} = articu_sc5;
articu_sc{1,6} = articu_sc6;
articu_sc{1,7} = articu_sc7;
    
training_data = [];
groups = [];

for iC=1:7
    sc = articu_sc{1,iC};
    obj = size(sc,2);
    for i0=1:obj
            %fprintf('----------------\n');
        sctemp = reshape(sc{1,i0},1,60*200);
        training_data = [training_data;sctemp];
        groups = [groups;iC];
    end
end

nbclass=7;
[n1, n2]=size(training_data);

%-----------------------------------------------------
%   Learning and Learning Parameters
c = 1000;
lambda = 1e-7;
kerneloption= 2;
kernel='gaussian';
verbose = 1;

%---------------------One Against All algorithms----------------
[xsup,w,b,nbsv]=svmmulticlassoneagainstall(training_data,groups,nbclass,c,lambda,kernel,kerneloption,verbose);

%----Testing ------------------------------------
test_articu_sc = cell(1,7);
test_articu_sc{1,1} = test_articu_sc1;
test_articu_sc{1,2} = test_articu_sc2;
test_articu_sc{1,3} = test_articu_sc3;
test_articu_sc{1,4} = test_articu_sc4;
test_articu_sc{1,5} = test_articu_sc5;
test_articu_sc{1,6} = test_articu_sc6;
test_articu_sc{1,7} = test_articu_sc7;
    
testing_data = [];
classes = [];

for iC=1:7
    sc = test_articu_sc{1,iC};
    obj = size(sc,2);
    for i0=1:obj
        sctemp = reshape(sc{1,i0},1,60*200);
        testing_data = [testing_data;sctemp];
        classes = [classes;iC];
    end
end

[pred,maxi] = svmmultival(testing_data,xsup,w,b,nbsv,kernel,kerneloption);
cp = classperf(pred,classes);
cp.CorrectRate
cp.CountingMatrix