function articu_sc = signbatch_comp_articu_sc( sdir,name,sCont, n_dist,n_theta, bTangent, bSmoothCont,n_class,n_obj,b_simplecont)

	if ~exist('b_simplecont')	b_simplecont=1;	end
	fprintf('Compute all shape context ...............................\n\n');

	load(sCont);		% get 'mpeg7_cont'
	articu_sc	= cell(n_class,n_obj);
	
	for iC=1:n_class
		for iO=1:n_obj
			fn	= [sdir name i2s(iO) '.bmp'];
			im	= double(imread(fn));
			fprintf('class %2d, object %2d :  ', iC,iO);
			fg_mask		= double(im>.5);
		
			ifig		= -1;
			tic;
			if b_simplecont
				cont		= articu_cont{iC,iO};
				[sc,V,E,dis_mat,ang_mat] = compu_contour_innerdist_SC( ...
												cont, fg_mask, ...
												n_dist, n_theta, bTangent, bSmoothCont,...
												ifig);
			else
				conts		= articu_cont{iC,iO};
				[sc,V,E,dis_mat,ang_mat] = compu_multi_contour_innerdist_SC( ...
												conts, fg_mask, ...
												n_dist, n_theta, bTangent, bSmoothCont,...
												ifig);
			end
			n_time		= toc;	
			fprintf('|V|=%4d\n', size(V,1));

			articu_sc{iC,iO}	= sc;

			if 0
				figure(432); clf; hold on;
				plot(V(:,1),V(:,2),'k-');
				disp_graph(V,E);
				%pause;
				disp_schist(fg_mask,V,sc,n_dist,n_theta);			
			end
		end
	end
