clear;
addpath common_innerdist;

%-----------------Parameters------------------------------------
ifig            = -1;
sdir		='dataset/train/';
test_dir    ='dataset/test/';


n_class                 = 2;
n_obj                   = 100;
n_objall                = n_obj*n_class;

test_n_class = 2;
test_n_obj = 100;

%--------------shape context descriptors--------------------

n_dist          = 5;
n_theta         = 12;
bTangent        = 1;
bSmoothCont     = 1;
n_contsamp      = 200;

%-----------Files--------------------
%-- Training-----------------------
sDisAngSamp     = ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
sCont           = [sdir 'articu_cont_' i2s(n_contsamp) '.mat'];
s_articu_sc     = [sdir 'SC' sDisAngSamp '.mat'];

%-- Testing -----------------------
test_DisAngSamp     = ['_' i2s(n_dist,2) 'x' i2s(n_theta,2) 'x' i2s(n_contsamp,3)];
test_Cont           = [test_dir 'test_articu_cont_' i2s(n_contsamp) '.mat'];
t_articu_sc     = [test_dir 'SC' test_DisAngSamp '.mat'];


%fprintf('%s,\n\n', sDisAngSamp);

%-- Extract contours -------------------------------------------------------------
if 1
        [articu_cont] = batch_contour_f(sdir,n_class,n_obj);
        [articu_cont] = batch_contour_f(sdir,n_class,n_obj,n_contsamp);
else
        load(sCont);
end
%-- Testing ------------------------------
if 1
	[test_articu_cont] = test_contour_f(test_dir,test_n_class,test_n_obj);
	[test_articu_cont] = test_contour_f(test_dir,test_n_class,test_n_obj,n_contsamp);
else
    load(test_Cont);
end

%-- Compute or Load all the shape context data ------------------------------------
%-- Training----------------------
if 1
        [articu_sc] = batch_comp_normal_sc(sdir,sCont,n_dist, n_theta, bTangent,n_class,n_obj);
        save(s_articu_sc, 'articu_sc');
else
        load(s_articu_sc);
end

%-- Testing -----------------------
if 1
        [test_articu_sc] = test_comp_normal_sc(test_dir,test_Cont,n_dist, n_theta, bTangent,test_n_class,test_n_obj);
        save(t_articu_sc, 'test_articu_sc');
else
        load(t_articu_sc);
end

svmModel = get_svmModel(articu_sc);
[classes,cp] = svm_classify_old(svmModel, test_articu_cont, test_articu_sc);

%-- Display classes ------

for i=1:2*n_obj
    fprintf('%d class=%d\n',i,classes(i));
end

%-- get accuracy ---------
cp.CorrectRate
return;