function [test_articu_cont,articu_cont_n] = test_contour_f(test_dir,test_n_class,test_n_obj,n_contsamp)

fprintf('Compute test contours ......................... \n');
		
sOriCont		= [test_dir 'test_articu_cont.mat'];
n_class = test_n_class;
n_obj = test_n_obj;

% original contour
if ~exist('n_contsamp')
	test_articu_cont		= cell(n_class,n_obj);
	%figure(20); clf; hold on;
	for iC=1:n_class
		for iO=1:n_obj
			fn	= [test_dir 'database_' i2s(iC) '_'  i2s(iO) '.bmp'];
			im	= double(imread(fn));
	
			%- Extract contour, count only the longest contours
			[Cs]	= boundary_extract_binary(im);
			n_max	= 0;
			i_max	= 0;
			for ii=1:length(Cs)
				if size(Cs{ii},2)>n_max
					n_max = size(Cs{ii},2);
					i_max = ii;
				end
			end
			cont	= Cs{i_max}';

			% remove redundant point in contours
			cont		= [cont; cont(1,:)];
			dif_cont	= abs(diff(cont,1,1));
			id_gd		= find(sum(dif_cont,2)>0.001);
			cont		= cont(id_gd,:);
			
			% force the contour to be anti-clockwisecomputed above is at the different orientation
			%bClock		= is_clockwise(cont,im);
			%if bClock	cont	= flipud(cont);		end
			
			% start from bottom left
			[min_v,id]	= min(cont(:,2)+cont(:,1));
			cont		= circshift(cont,[length(cont)-id+1]);
			
			test_articu_cont{iC,iO}	= cont;
			%fprintf('%2d, original clockwise=%d\n', iO,bClock);
			if 0	% test
				subplot(2,n_obj,iO+iC*n_obj-n_obj);	hold on;
				plot(cont(:,1),cont(:,2),'-');
				plot(cont(1,1),cont(1,2),'r+');
				plot(cont(50,1),cont(50,2),'ro');
				title([i2s(length(cont))]);
				axis tight;	axis equal;	axis off;
% 				drawnow, keyboard;				
			end
		end
	%	print(20,'-r350', '-djpeg', [test_dir 'cont.jpg']);
	end
	
	save(sOriCont,'test_articu_cont');
end



%-------------- downsampling contour
if exist('n_contsamp')
	sCont	= [test_dir 'test_articu_cont_' i2s(n_contsamp) '.mat'];
	if ~exist('test_articu_cont')	load(sOriCont);	end

	%figure(21); clf; hold on;
	for iC=1:n_class
		fprintf('Class %2d \n', iC);
		for iO=1:n_obj

			cont		= test_articu_cont{iC,iO};
			[XIs,YIs]	= uniform_interp(cont(:,1),cont(:,2),n_contsamp-1);
			cont		= [cont(1,:); [XIs YIs]];
			test_articu_cont{iC,iO}	= cont;
	
			if 0	%test
				subplot(2,n_obj,iO+iC*n_obj-n_obj);	hold on;
				plot(cont(:,1),cont(:,2),'b-');
				plot(cont(1,1),cont(1,2),'r+');
				plot(cont(10,1),cont(10,2),'ro');
				%title([i2s(length(cont))]);
				axis tight;	axis equal;	axis off;
			end
		end
	end
	
	%print(21,'-r300', '-djpeg',[test_dir 'cont_' i2s(n_contsamp) '.jpg']);
	save(sCont,'test_articu_cont');
end

fprintf('\n    finished computing contours.\n');